{

 PAL_256x256_demo.SPIN
 VERSION: 0.0
 AUTHOR: GV
 LAST MODIFIED: 6/6/2008
 COMMENTS: derived from simple ntsc driver

}

CON

  ' This will allow us to use Coleys Hardware detect routine...
  _CLKMODE = RCSlow      ' Start prop in RCSlow mode internal crystal

  ' What kind of system are we dealing with.
  TYPE_HYDRA  = 1
  TYPE_HYBRID = 2
  TYPE_DEMO   = 0

  TILE_X  = 32
  TILE_Y  = 32
  T_PIXEL = 8
  
VAR

  long params[7]
  word map, screen, colors
  long pingroup, pinmaskIO, pinmaskVCFG, VCFG_mode
   
OBJ

   tv : "PAL_256x256_colors_drv.spin"
 tile : "PAL_256x256_colors_tile.spin" 
                                 
PUB start | type, temp, i, ii

    type := HWDetect

    CASE type
       TYPE_HYDRA :
        pingroup     := 3               ' Set Pingroup used by TV driver.
        pinmaskIO    := %0000_0111<<24  ' Set Pinmaks for output pins.
        pinmaskVCFG  := %0000_0111      ' Set Pinmaks for VCFG pins.
        VCFG_mode    := %0_10_111_000   ' baseband video on bottom nibble, 2-bit color, enable chroma on broadcast & baseband 
       TYPE_HYBRID :                    ' %0_xx_x_x_x_xxx : Not used                                                          
        pingroup     := 3               ' %x_10_x_x_x_xxx : Composite video to top nibble, broadcast to bottom nibble         
        pinmaskIO    := %0000_0111<<24  ' %x_xx_1_x_x_xxx : 4 color mode                                                      
        pinmaskVCFG  := %0000_0111      ' %x_xx_x_1_x_xxx : Enable chroma on broadcast                                         
        VCFG_mode    := %0_10_111_000   ' %x_xx_x_x_1_xxx : Enable chroma on baseband                                                                 
       TYPE_DEMO :                      ' %x_xx_x_x_x_000 : Broadcast Aural FM bits (don't care)                              
        pingroup     := 1               
        pinmaskIO    := %0000_0111<<12  
        pinmaskVCFG  := %0111_1000      
        VCFG_mode    := %0_11_101_111   

    map        := tile.map_adr          
    screen     := tile.tile_adr         
    colors     := tile.color_adr        
                                        
    params[0]  := map                   
    params[1]  := screen                     
    params[2]  := colors 
    params[3]  := VCFG_mode
    params[4]  := pingroup
    params[5]  := pinmaskIO
    params[6]  := pinmaskVCFG

    tv.start(@params)     

     'loop 1
    repeat 5
      waitcnt(100_000_000 + cnt)
      if (temp//2)
        params[1] := screen + $70
      else
        params[1] := screen
      temp := temp ^ 1

    'demo by il punto srl
    clrscr
    waitcnt(2_000_000 + cnt)
    print(14,14, "d")
    waitcnt(2_000_000 + cnt)
    print(15,14, "e")
    waitcnt(2_000_000 + cnt)
    print(16,14, "m")
    waitcnt(2_000_000 + cnt)
    print(17,14, "o")
    waitcnt(100_000_000 + cnt)

     'loop 2
    repeat 5
      waitcnt(100_000_000 + cnt)
        repeat i  from 0 to 35
          repeat ii from 0 to 1023 
             word[params[0]][ii] := (i+1)<<8 + i
    
          waitcnt(50_000_000 + cnt)
 
    'fine
    clrscr
    waitcnt(100_000_000 + cnt)
    print(14,16, "c")
    waitcnt(100_000_000 + cnt)
    print(15,16, "i")
    waitcnt(100_000_000 + cnt)
    print(16,16, "a")
    waitcnt(100_000_000 + cnt)
    print(17,16, "o")

PRI clrscr | i
    repeat i from 0 to 1023 
      word[params[0]][i] := 36

PRI print(x,y,text) | pos, char
    pos  := TILE_X*y+x
    char := text - 87
    word[params[0]][pos] :=  35<<8 + char
     
PRI HWDetect | HWPins, Type

  ' //////////////////////////////////////////////////////
  ' AUTHOR: Coley
  ' LAST MODIFIED: 23.06.08
  ' VERSION 1
  ' COMMENTS: Routine for checking Hardware configurations
  '           of various Propeller based boards.             
  ' //////////////////////////////////////////////////////
  '
  '  Power on harware configurations for target boards
  '
  '                      Pin Number
  '
  '            00000000001111111111222222222233
  '            01234567890123456789012345678901
  '
  '                                    vdac
  ' Hybrid     000000001111111100000000OOOO1111
  '
  '                        vdac
  ' Demoboard  000000000000OOOO0000000011110111
  '
  '                                    vdac
  ' Hydra      010001000101010111110000OOOO??11 
  '
  ' For this application we will check the status
  ' of P12..P13
  '
  ' %00 - Demo/Protoboard
  ' %01 - Hydra
  ' %11 - Hybrid
  '
  ' //////////////////////////////////////////////////////
   
   clkset(%01101000,  12_000_000)                        ' Set internal oscillator to RCFast and set PLL to start
   waitcnt(cnt+120_000)                                  ' wait approx 10ms at 12mhz for PLL to 'warm up'
   
   HWPins := INA[12..13]                                 ' Check state of Pins 12-13
   
   CASE HWPins
     %00 : clkset( %01101111, 80_000_000 )               ' Demo Board   80MHz (5MHz PLLx16)  
           Type    := 0      
     %01 : clkset( %01110110, 80_000_000 )               ' Hydra        80MHz (10MHz PLLx8)
           Type    := 1
     %11 : clkset( %01101111, 96_000_000 )               ' Hybrid       96MHz (6MHz PLLx16)
           Type    := 2
   
  ' Modified to return Type of system.
  return Type  