{

 PAL_256x256_demo.SPIN
 VERSION: 0.0
 AUTHOR: GV
 LAST MODIFIED: 6/6/2008
 COMMENTS: derived from simple ntsc driver

}

CON

  'HYDRA setting
  '_CLKMODE = XTAL1 + PLL8x
  '_XINFREQ = 10_000_000

CON
   PAL_FREQ                     =    4_433_618
   
   PAL_SCANLINE_CLOCKS          =    4544
   PAL_HSYNC_CLOCKS             =    848
   PAL_VSYNC_CLOCKS             =    PAL_SCANLINE_CLOCKS/2
   PAL_ACTIVE_VIDEO_CLOCKS      =    PAL_SCANLINE_CLOCKS - PAL_HSYNC_CLOCKS

   CLOCKS_PER_PIXEL             =    12
   PIXEL_PER_FRAME              =    8
   X_RES                        =    256
   Y_RES                        =    256
   HORZ_OFFSET                  =    -15

   CLOCKS_PER_FRAME             =    CLOCKS_PER_PIXEL * PIXEL_PER_FRAME
   FRAMES_PER_LINE              =    X_RES / PIXEL_PER_FRAME
   OVERSCAN                     =    PAL_ACTIVE_VIDEO_CLOCKS - FRAMES_PER_LINE * CLOCKS_PER_FRAME
   BACKPORCH                    =    OVERSCAN / 2 + HORZ_OFFSET
   FRONTPORCH                   =    OVERSCAN - OVERSCAN / 2 - HORZ_OFFSET
   
VAR
  byte cog               
  
PUB start(params)
  cog:=cognew(@entry, params)
 
DAT                             org
entry                   jmp     #inizio          

PAL_COLOR_FREQ                  long  PAL_FREQ
PAL_SYNC_COLOR                  long  $00_00_02_AA

PAL_HSYNC_VSCL                  long  PAL_HSYNC_CLOCKS >> 4 << 12 + PAL_HSYNC_CLOCKS '848/16  = 53.

PAL_VSYNC_VSCL                  long  PAL_VSYNC_CLOCKS >> 4 << 12 + PAL_VSYNC_CLOCKS '2272/16 = 142
PAL_VIDEO_VSCL                  long  PAL_ACTIVE_VIDEO_CLOCKS 
PAL_TILE_VSCL                   long  CLOCKS_PER_PIXEL << 12 + CLOCKS_PER_FRAME

'Pixel streams
'These are shifted out of the VSU to the right, so lowest bits are actioned first.
'
hsync                           long  %%11_0000_1_222222_11          '2 = blanking level, 1 = Black, 0 = Burst color

vsync_long                      long  %%222222222222222_1            'long sync  30us sync + 2us black
vsync_short                     long  %%111111111111111_2            'short_sync 2us black + 30us sync pre\post equalizing 

all_black                       long  %%1111111111111111
border                          long  %%0000000000000000

' General Purpose Registers
'
r0                              long  $0
r1                              long  $0
r2                              long  $0
r3                              long  $0                      

' Video (TV) Registers
'
tvport_mask                     long  $0
VCFG_PinGrp                     long  $0
VCFG_PinMask                    long  $0
VCFG_mode                       long  $0

' Graphics related vars.
'
v_clkfreq                       long  $0
v_sync                          long   1                             'Default: 1 = (6-5-5) - 0 = (5-5-4)


' variabili mappa, pixels, colori
'
map_ptr                         long  $0
map_ptr_tmp                     long  $0
map_pixel                       long  $0
map_color                       long  $0

gfx_ptr                         long  $0
gfx_ptr_tmp                     long  $0
gfx_used                        long  $0

col_ptr                         long  $0
col_ptr_tmp                     long  $0
col_used                        long  $0

'linee logiche e tiles
'
line_loop                       long  $0
tile_loop                       long  $0
y_offset                        long  $0
        
DAT

'----------------------------------------------------------------------------- 
'Driver
'----------------------------------------------------------------------------- 
inizio                  mov     r0,             PAR                  'Get parameter block address
                        add     r0,             #12                  'Recupera video cfg
                        rdlong  VCFG_mode,      r0
                        add     r0,             #4                              
                        rdlong  VCFG_PinGrp,    r0
                        add     r0,             #4                              
                        rdlong  tvport_mask,    r0
                        add     r0, #4                                          
                        rdlong  VCFG_PinMask,   r0                

                        movs    VCFG,           VCFG_PinMask         'VCFG'S = pinmask (pin31: 0000_0111 : pin24)
                        movd    VCFG,           VCFG_PinGrp          'VCFG'D = pingroup (grp. 3 i.e. pins 24-31)
                        movi    VCFG,           VCFG_mode            'Baseband video on bottom nibble, 2-bit color, enable chroma on baseband
                        or      DIRA,           tvport_mask          'Set DAC pins to output

                        movi    CTRA,           #%00001_111          'pll internal routed to Video, PHSx+=FRQx (mode 1) + pll(16x)
                        mov     r1,             PAL_COLOR_FREQ       'r1: Color frequency in Hz (4.433_618Hz)
                        rdlong  v_clkfreq,      #0                   'copy clk frequency. (80Mhz)
                        mov     r2,             v_clkfreq            'r2: CLKFREQ (80MHz)
                        call    #divide                              'perform r3 = 2^32 * r1 / r2
                        mov     FRQA,           r3                   'r3 now contains frqa.     

'-----------------------------------------------------------------------------
frame_loop              mov     r0,             PAR                  'Get parameter block address
                        rdlong  map_ptr,        r0                   'Get map address                              
                        add     r0,             #4                   
                        rdlong  gfx_ptr,        r0                   'Get screen address
                        add     r0,             #4
                        rdlong  col_ptr,        r0                   'Get color address
                        mov     y_offset,       #0                            
                        mov     r0,             #0                        
'-----------------------------------------------------------------------------
                        mov     line_loop,      #18                  'Draw invisible lines
:invisible_lines        mov     VSCL,           PAL_HSYNC_VSCL
                        waitvid PAL_SYNC_COLOR, hsync
                        mov     VSCL,           PAL_VIDEO_VSCL
                        waitvid PAL_SYNC_COLOR, #1   
                        djnz    line_loop,      #:invisible_lines
'-----------------------------------------------------------------------------
                        mov     line_loop,      #13                  'Linee bordo superiore
:vert_back_porch        mov     VSCL,           PAL_HSYNC_VSCL
                        waitvid PAL_SYNC_COLOR, hsync
                        mov     VSCL,           PAL_VIDEO_VSCL
                        waitvid BORDER_COL,     #0
                        djnz    line_loop,      #:vert_back_porch
'-----------------------------------------------------------------------------
                        mov     line_loop,      #Y_RES                                                      
:user_graphics_lines    mov     VSCL,           PAL_HSYNC_VSCL       'hsync
                        waitvid PAL_SYNC_COLOR, hsync                '      
                        mov     VSCL,           #BACKPORCH           'The overscan before the user graphics. 
                        waitvid BORDER_COL,     #0                                                                                                                                        
                        mov     VSCL,           PAL_TILE_VSCL        'And now at long last, the user graphics.
                        mov     tile_loop,      #FRAMES_PER_LINE     'Recupera colori, pixel e disegna per
'-----------------------------------------------------------------------------                        
:tiles_loops            rdbyte  map_pixel,      map_ptr              'recupera offset per i pixels                              
                        add     map_ptr,        #1                   '__ avanza di 1 byte da colore a pixel                                               
                        mov     gfx_ptr_tmp,    gfx_ptr              '__ puntatore iniziale pixels

                        rdbyte  map_color,      map_ptr              'recupera offset per la palette (little endian)
                        add     map_ptr,        #1                   '__ avanza di 1 byte da pixel a colore
                        mov     col_ptr_tmp,    col_ptr              '__ puntatore iniziale colori
                         
                        shl     map_pixel,      #4                   'moltiplica per 16 per trovare la posizione es. $01 a $10
                        add     gfx_ptr_tmp,    map_pixel            'somma offset al puntatore iniziale dei pixels
                        add     gfx_ptr_tmp,    y_offset             'somma offset di linea (da 1 a 8)

                        rdword  gfx_used,       gfx_ptr_tmp          'recupera valore dall'HUB ram

                        add     col_ptr_tmp,    map_color            '__ somma offset al puntatore iniziale della palette
                        rdlong  col_used,       col_ptr_tmp          'recupera valore dall'HUB ram
                       
                        waitvid col_used,       gfx_used             'disegna 8 pixels da sx a dx                                                
                        djnz    tile_loop,      #:tiles_loops        'controlla se sono state disegnati i 32 frame
                        
                        add     y_offset,       #2                   'muove le word da 1 a 8 per tile per ogni linea
                        cmp     y_offset,       #16     wz, wc       'controlla se si tratta dell'ottava linea della tile       
              if_e      mov     y_offset,       #0                   'se raggiunte le 8 linee della tile, azzera           
              if_ne     sub     map_ptr,        #64                  'stessa mappa se le linee sono < 8     
                        
:end_of_tiles_line      mov     VSCL,           #FRONTPORCH          'Terminata la generazione della linea,                                                                     
                        waitvid BORDER_COL ,    border        
                        djnz    line_loop,      #:user_graphics_lines
'-----------------------------------------------------------------------------
                        mov     line_loop,      #13                  'linee di bordo inferiore (304)
:vert_front_porch       mov     VSCL,           PAL_HSYNC_VSCL
                        waitvid PAL_SYNC_COLOR, hsync
                        mov     VSCL,           PAL_VIDEO_VSCL
                        waitvid BORDER_COL,     #0
                        djnz    line_loop,      #:vert_front_porch
'-----------------------------------------------------------------------------
' odd: 6,5,5 and even 5,5,4 vsync
'-----------------------------------------------------------------------------
                        'xor     v_sync,         #1      
                        mov     VSCL,           PAL_VSYNC_VSCL                        
                        mov     line_loop,      #2
                        cmp     v_sync,         #1      wz, wc
              if_e      mov     line_loop,      #3                  
:vsync_higha            waitvid PAL_SYNC_COLOR, vsync_short
                        waitvid PAL_SYNC_COLOR, vsync_short
                        djnz    line_loop,      #:vsync_higha
                        cmp     v_sync,         #0      wz, wc
              if_e      waitvid PAL_SYNC_COLOR, vsync_short           
'-----------------------------------------------------------------------------
                        mov     line_loop,      #2                   '
:vsync_low              waitvid PAL_SYNC_COLOR, vsync_long
                        waitvid PAL_SYNC_COLOR, vsync_long
                        djnz    line_loop,      #:vsync_low
'-----------------------------------------------------------------------------
:vsync_mix              waitvid PAL_SYNC_COLOR, vsync_long
                        cmp     v_sync,         #1      wz, wc
              if_e      waitvid PAL_SYNC_COLOR, vsync_short
'-----------------------------------------------------------------------------
                        mov     line_loop,      #2                   '
:vsync_highb            waitvid PAL_SYNC_COLOR, vsync_short
                        waitvid PAL_SYNC_COLOR, vsync_short
                        djnz    line_loop,      #:vsync_highb
'-----------------------------------------------------------------------------
                        jmp     #frame_loop
'-----------------------------------------------------------------------------
' Fine
'-----------------------------------------------------------------------------
' divide:
' Perform 2^32 * r1/r2, result stored in r3 (useful for TV calc)
'
divide                                          
                        mov     r0,#32+1
:loop                   cmpsub  r1,r2           wc
                        rcl     r3,#1
                        shl     r1,#1
                        djnz    r0,#:loop

divide_ret              ret                                          '+140
                        
'Palettes
'4 colors (or blanking level) stored in 
'reverse order: Color3_Color2_Color1_Color0
'
BORDER_COL              long    $00_00_00_4b